=== debian/changelog ===
ring (20180228.1.503da2b~ds1-1build1) bionic; urgency=medium

  * No-change rebuild against latest evolution-data-server

 -- Jeremy Bicha <jbicha@ubuntu.com>  Sat, 03 Mar 2018 20:01:46 -0500

ring (20180228.1.503da2b~ds1-1) unstable; urgency=medium

  * New upstream version.

 -- Alexandre Viau <aviau@debian.org>  Wed, 28 Feb 2018 12:19:23 -0500

ring (20180222.1.7bffde2~ds2-2) unstable; urgency=medium

  * Depend on libqt5sql5-sqlite (Closes: #891460)

 -- Alexandre Viau <aviau@debian.org>  Tue, 27 Feb 2018 01:43:36 -0500

ring (20180222.1.7bffde2~ds2-1) unstable; urgency=medium

  * New upstream version.
  * d/copyright: exclude vendored kashmir.
  * Exclude pjsip-apps from tarball.
  * Depend on opendht >= 1.6.0.
  * d/copyright: fix insecure-copyright-format-uri.
  * d/copyright: remove unused sections.

 -- Alexandre Viau <aviau@debian.org>  Tue, 27 Feb 2018 01:33:04 -0500

ring (20180119.1.9e06f94~ds1-3) unstable; urgency=medium

  * Cleanup d/changelog.
  * Build msgpack-c v2 API.

 -- Alexandre Viau <aviau@debian.org>  Thu, 01 Feb 2018 17:49:53 +0000

ring (20180119.1.9e06f94~ds1-2) unstable; urgency=medium

  * Build with gcc-7. (Closes: #853642)

 -- Alexandre Viau <aviau@debian.org>  Thu, 01 Feb 2018 01:00:59 -0500

ring (20180119.1.9e06f94~ds1-1) unstable; urgency=medium

  * New upstream snapshot.
  * Don't depend on libwebkit2gtk-3.0-dev. (Closes: #871962)
  * Depend on libcanberra-gtk3-dev.
  * Move to libnm. (Closes: #862764)

 -- Alexandre Viau <aviau@debian.org>  Fri, 26 Jan 2018 10:28:47 -0500

ring (20171129.2.cf5bbff~ds1-2) unstable; urgency=medium

  * Move to salsa.debian.org

 -- Alexandre Viau <aviau@debian.org>  Thu, 28 Dec 2017 16:54:31 -0500
