=== debian/watch ===
version=3
opts=dversionmangle=s/\~ds\d*$// \
https://dl.ring.cx/ring-release/tarballs/ ring_(\d\S*)\.tar\.gz
